//gun.cs

datablock ParticleData(PlasmaBeamerExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 150;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0 0 1 1.0";
	colors[1]     = "0.5 0.85 1 0.8";
	colors[2]     = "1 1 1 0.6";
	sizes[0]      = 3;
	sizes[1]      = 2.5;
	sizes[2]      = 1;
   times[0] = 0.0;
   times[1] = 0.1;
   times[2] = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(PlasmaBeamerExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 8;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PlasmaBeamerExplosionRingParticle";

   useEmitterColors = false;
};

datablock ExplosionData(PlasmaBeamerExplosion)
{
   //explosionShape = "";
	soundProfile = PBHitSound;

   lifeTimeMS = 150;

   emitter[0] = PlasmaBeamerExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "0.0 0 0";
   camShakeAmp = "0 0 0";
   camShakeDuration = 0.0;
   camShakeRadius = 0.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0 0.3 0.9";
   lightEndColor = "0 0 0";

   //impulseRadius = 0;
   //impulseForce = 1000;
};


AddDamageType("PlasmaBeamer",   '<bitmap:add-ons/Weapon_PlasmaBlaster/CI_PBL> %1',    '%2 <bitmap:add-ons/Weapon_PlasmaBlaster/CI_PBL> %1',0.2,1);

datablock ProjectileData(PlasmaBeamerProjectile : gunProjectile)
{
   projectileShapeName = "./raycastline_electricity.dts";
   explosion           = PlasmaBeamerExplosion;
};

function drawRaylinePlasmaBeam(%pos1, %pos2)
{
	//should be the dimensions of the model in torque units
	%modelwidth = 0.2 +getRandom(1,10)*0.01;
	%modeldepth = 0.2 +getRandom(1,10)*0.01;
	%modelheight = 1.3 +getRandom(1,10)*0.1;

	//find the point halfway between the two points, this will be our position
	%point = vectorAdd(vectorScale(vectorSub(%pos2, %pos1), 0.5), %pos1);
	
	//rotation
	%xRot = 0;
	
	//mAtan(z/len(x and y))
	%yRot = 90 - mRadToDeg(mAtan(getWord(%pos2, 2) - getWord(%pos1, 2), vectorLen(vectorSub(getWords(%pos2, 0, 1), getWords(%pos1, 0, 1)))));
	//%yRot = 90;
	
	//mAtan(x/y)
	%zRot = mRadToDeg(mAtan(getWord(%pos2, 1) - getWord(%pos1, 1), getWord(%pos2, 0) - getWord(%pos1, 0)));
	
	%rot = eulerToAxis(%xRot SPC %yRot SPC %zRot);
	
	//scaling
	%width = 0.3 / %modelWidth;
	%depth = 0.3 / %modeldepth;
	%height = vectorLen(vectorSub(%pos2, %pos1)) / %modelheight;
	
	
	//create it
	%shape = new TSStatic() {
    shapeName = "add-ons/Weapon_PlasmaBlaster/PlasmaBeamerLaser.dts";	};
	
	%shape.setTransform(%point SPC %rot);
	%shape.setScale(%width SPC %depth SPC %height);
	
	$lastShape = %shape;
	
	return %shape;
}


//////////
// item //
//////////
datablock ItemData(PlasmaBeamItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./PlasmaBeamerGun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "FF - Plasma Beamer";
	iconName = "./Icon_PBL";
	doColorShift = false;
	colorShiftColor = "0.7 0.7 0.75 1.000";

	 // Dynamic properties defined by the scripts
	image = PlasmaBeamImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(PlasmaBeamImage)
{
   // Basic Item properties
	shapeFile = "./PlasmaBeamerGun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = gunProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = PlasmaBeamItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   raycastWeaponRange = 55; //varies
   raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   raycastExplosionProjectile = PlasmaBeamerProjectile;
   raycastExplosionBrickSound = PBHitSound;
   raycastExplosionPlayerSound = PBHitSound;
   raycastDirectDamage = 22; //10
   raycastDirectDamageType = $DamageType::PB;
   raycastSpreadAmt = 0.0000; //varies
   raycastSpreadCount = 0;
   raycastFromMuzzle = true;

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	//stateSequence[0]	= "Fire";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateTransitionOnTimeout[1]     = "Ready";
	stateWaitForTimeout[1]			= false;
	stateTimeoutValue[1]            = 0.9;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.13;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= PBFireSound;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateTransitionOnTimeout[3]     = "Fire";
	stateTransitionOnTriggerUp[3]     = "Ready";
	stateSequence[3]	= "Ready";
};

function PlasmaBeamImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() >= 1.0)
		return;		
	
	Parent::onFire(%this,%obj,%slot);

	////////////////////////////////////////////////////
	%range = %this.raycastWeaponRange;

	%start = %obj.getMuzzlePoint(%slot);
	%end = vectorAdd(%start, vectorScale(%obj.getMuzzleVector(%slot), %range));

	%typemasks = $Typemasks::PlayerObjectType | $Typemasks::FxBrickObjectType | $Typemasks::TerrainObjectType | 
		$TypeMasks::StaticObjectType | $TypeMasks::VehicleObjectType;

	%ray = containerRaycast(%start, %end, %typemasks, %obj);

	if(isObject(%hit = firstWord(%ray)))
	{
		%line = drawRaylinePlasmaBeam(%start, getWords(%ray, 1, 3));
	}else{
		%line = drawRaylinePlasmaBeam(%start, %end);
	}
	%line.schedule(140, delete);
}
