datablock AudioProfile(PBHitSound)
{
   filename    = "./PBHit.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(PBFireSound)
{
   filename    = "./PBBlast.wav";
   description = AudioClose3d;
   preload = true;
};


datablock ParticleData(PBExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 2.0;
	spinRandomMin		= -20.0;
	spinRandomMax		= 20.0;
	colors[0]     = "0 0.4 1 0.5";
	colors[1]     = "0 0.4 1 0.0";
	sizes[0]      = 0.75;
	sizes[1]      = 0.0;

	useInvAlpha = true;
};

datablock ParticleEmitterData(PBExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PBExplosionParticle";

   useEmitterColors = true;
   uiName = "Plasma Blaster Explosion";
};

datablock ExplosionData(PBExplosion)
{
   //explosionShape = "";
	soundProfile = PBHitSound;

   lifeTimeMS = 150;

   particleEmitter = PBExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1.5 1.5 1.5";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 5;
   lightStartColor = "0 0.4 1 1";
   lightEndColor = "0 0.4 1 1";
};


AddDamageType("PB",   '<bitmap:add-ons/Weapon_PlasmaBlaster/CI_PB> %1',    '%2 <bitmap:add-ons/Weapon_PlasmaBlaster/CI_PB> %1',0.2,1);
datablock ProjectileData(PBProjectile)
{
   projectileShapeName = "./PlasmaBlasterProjectile.dts";
   directDamage        = 28;
   directDamageType    = $DamageType::PB;
   radiusDamageType    = $DamageType::PB;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 1;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 200;
   verticalImpulse	  = 50;
   explosion           = PBExplosion;

   muzzleVelocity      = 80;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 6000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0.4 1 1";

   uiName = "Plasma Blaster Plasma";
};

//////////
// item //
//////////
datablock ItemData(PBItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./PlasmaBlasterGun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "FF - Plasma Blaster";
	iconName = "./Icon_PB";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = PBImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(PBImage)
{
   // Basic Item properties
   shapeFile = "./PlasmaBlasterGun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = PBItem;
   ammo = " ";
   projectile = PBProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 35;
   doColorShift = false;
   colorShiftColor = PBItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.25;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]				 = "Ready";

	stateName[2]					 = "Fire";
	stateTransitionOnTimeout[2]	     = "Smoke";
	stateTimeoutValue[2]			 = 0.1;
	stateFire[2]					 = true;
	stateAllowImageChange[2]		 = false;
	stateSequence[2]				 = "Fire";
	stateScript[2]					 = "onFire";
	stateWaitForTimeout[2]			 = true;
	stateEmitterTime[2]				 = 0.05;
	stateEmitterNode[2]				 = "muzzleNode";
	stateSound[2]					 = PBFireSound;
	stateEjectShell[2]			 	 = false;

	stateName[3] = "Smoke";
	stateEmitterTime[3]				 = 0.01;
	stateEmitterNode[3]				 = "muzzleNode";
	stateTimeoutValue[3]			 = 0.01;
	stateTransitionOnTimeout[3]	     = "Ready";

	stateName[4]					 = "Reload";
	stateSequence[4]				 = "Reload";
	stateTransitionOnTriggerUp[4]	 = "Ready";
	stateSequence[4]				 = "Ready";
};