function test()
{
	drawLine(point1.getPosition(), findclientbyname("a").player.getPosition());
	$testSched = schedule(100, 0, "test");
}

function scaleLineThicknessTo(%line, %thickness)
{
	if(!isObject(%line))
		return;
	
	%scale = %line.getScale();
	%width = getWord(%scale, 0);
	%depth = getWord(%scale, 1);
	
	%width += 0.05;
	%depth += 0.05;
	if(%width > %thickness)
		%width = %thickness;
	if(%depth > %thickness)
		%depth = %thickness;
	
	if(isEventPending(%line.lineScaleSched))
		cancel(%line.lineScaleSched);
	
	if(%width < %thickness || %depth < %thickness)
		%line.lineScaleSched = schedule(60, 0, "scaleLineThicknessTo", %line, %thickness);
}

//from Trader
//http://forum.blockland.us/index.php?topic=27230.0
function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}
